Index: CKEditor/branches/versions/3.5.x/_source/lang/sr.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/sr.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/sr.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: 'Same Window (_self)', // MISSING
 		targetParent	: 'Parent Window (_parent)', // MISSING
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/sv.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/sv.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/sv.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: 'Same Window (_self)', // MISSING
 		targetParent	: 'Parent Window (_parent)', // MISSING
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/th.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/th.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/th.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: 'Same Window (_self)', // MISSING
 		targetParent	: 'Parent Window (_parent)', // MISSING
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/tr.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/tr.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/tr.js	(revision 5841)
@@ -105,5 +105,4 @@
 		targetSelf		: 'Aynı Pencere (_self)',
 		targetParent	: 'Ana Pencere (_parent)',
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/uk.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/uk.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/uk.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: 'Same Window (_self)', // MISSING
 		targetParent	: 'Parent Window (_parent)', // MISSING
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/vi.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/vi.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/vi.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: 'Tại trang (_self)',
 		targetParent	: 'Cửa sổ cha (_parent)',
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/zh-cn.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/zh-cn.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/zh-cn.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: '本窗口 (_self)',
 		targetParent	: '父窗口 (_parent)',
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/lang/zh.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/lang/zh.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/lang/zh.js	(revision 5841)
@@ -106,5 +106,4 @@
 		targetSelf		: 'Same Window (_self)', // MISSING
 		targetParent	: 'Parent Window (_parent)', // MISSING
-		advanced		: 'Advanced', // MISSING
 		langDirLTR		: 'Left to Right (LTR)', // MISSING
 		langDirRTL		: 'Right to Left (RTL)', // MISSING
Index: CKEditor/branches/versions/3.5.x/_source/plugins/bidi/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/bidi/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/bidi/plugin.js	(revision 5841)
@@ -12,10 +12,6 @@
 	function onSelectionChange( evt )
 	{
-		evt.editor.getCommand( 'bidirtl' ).setState( getState( evt.editor, evt.data.path, 'rtl' ) );
-		evt.editor.getCommand( 'bidiltr' ).setState( getState( evt.editor, evt.data.path, 'ltr' ) );
-	}
-
-	function getState( editor, path, dir )
-	{
+		var editor = evt.editor,
+			path = evt.data.path;
 		var useComputedState = editor.config.useComputedState,
 			selectedElement;
@@ -42,10 +38,17 @@
 			return CKEDITOR.TRISTATE_OFF;
 
-		selectedElement = useComputedState ?
+		var selectionDir = useComputedState ?
 			selectedElement.getComputedStyle( 'direction' ) :
 			selectedElement.getStyle( 'direction' ) || selectedElement.getAttribute( 'dir' );
 
-		return ( selectedElement == dir ) ?
-			CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF;
+		editor.getCommand( 'bidirtl' ).setState( selectionDir == 'rtl' ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
+		editor.getCommand( 'bidiltr' ).setState( selectionDir == 'ltr' ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
+
+		var chromeRoot = editor.container.getChild( 1 );
+
+		if ( selectionDir != editor.lang.dir )
+			chromeRoot.addClass( 'cke_mixed_dir_content' );
+		else
+			chromeRoot.removeClass( 'cke_mixed_dir_content' );
 	}
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/dialog/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/dialog/plugin.js	(revision 5841)
@@ -763,5 +763,5 @@
 			{
 				for ( var j in this._.contents[i] )
-					fn( this._.contents[i][j]);
+					fn( this._.contents[i][j] );
 			}
 			return this;
@@ -776,5 +776,5 @@
 		reset : (function()
 		{
-			var fn = function( widget ){ if ( widget.reset ) widget.reset(); };
+			var fn = function( widget ){ if ( widget.reset ) widget.reset( 1 ); };
 			return function(){ this.foreach( fn ); return this; };
 		})(),
@@ -2355,12 +2355,13 @@
 		 * Sets the value of this dialog UI object.
 		 * @param {Object} value The new value.
+		 * @param {Boolean} noChangeEvent Internal commit, to supress 'change' event on this element.
 		 * @returns {CKEDITOR.dialog.uiElement} The current UI element.
 		 * @example
 		 * uiElement.setValue( 'Dingo' );
 		 */
-		setValue : function( value )
+		setValue : function( value, noChangeEvent )
 		{
 			this.getInputElement().setValue( value );
-			this.fire( 'change', { value : value } );
+			!noChangeEvent && this.fire( 'change', { value : value } );
 			return this;
 		},
Index: CKEditor/branches/versions/3.5.x/_source/plugins/dialogadvtab/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/dialogadvtab/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/dialogadvtab/plugin.js	(revision 5841)
@@ -43,6 +43,4 @@
 	}
 }
-
-var isUpdating;
 
 CKEDITOR.plugins.add( 'dialogadvtab',
@@ -63,6 +61,6 @@
 		{
 			id : 'advanced',
-			label : lang.advanced,
-			title : lang.advanced,
+			label : lang.advancedTab,
+			title : lang.advancedTab,
 			elements :
 				[
@@ -145,10 +143,4 @@
 						updateStyle : function( name, value )
 						{
-							if ( isUpdating )
-								return;
-
-							// Flag to avoid recursion.
-							isUpdating = 1;
-
 							var styles = this.getValue();
 
@@ -168,7 +160,6 @@
 							}
 
-							this.setValue( styles );
-
-							isUpdating = 0;
+							this.setValue( styles, true );
+
 						},
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/dialogui/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/dialogui/plugin.js	(revision 5841)
@@ -60,7 +60,7 @@
 		},
 
-		reset : function()
+		reset : function( noChangeEvent )
 		{
-			this.setValue( this.getInitValue() );
+			this.setValue( this.getInitValue(), noChangeEvent );
 		},
 
@@ -1062,5 +1062,5 @@
 				{
 					!value && ( value = '' );
-					return CKEDITOR.ui.dialog.uiElement.prototype.setValue.call( this, value );
+					return CKEDITOR.ui.dialog.uiElement.prototype.setValue.apply( this, arguments );
 				},
 
@@ -1157,9 +1157,10 @@
 				 * @example
 				 * @param {Boolean} true to tick the checkbox, false to untick it.
-				 */
-				setValue : function( checked )
+				 * @param {Boolean} noChangeEvent Internal commit, to supress 'change' event on this element.
+				 */
+				setValue : function( checked, noChangeEvent )
 				{
 					this.getInputElement().$.checked = checked;
-					this.fire( 'change', { value : checked } );
+					!noChangeEvent && this.fire( 'change', { value : checked } );
 				},
 
@@ -1223,6 +1224,7 @@
 				 * @example
 				 * @param {String} value The value of the button to be chcked.
-				 */
-				setValue : function( value )
+				 * @param {Boolean} noChangeEvent Internal commit, to supress 'change' event on this element.
+				 */
+				setValue : function( value, noChangeEvent )
 				{
 					var children = this._.children,
@@ -1230,5 +1232,5 @@
 					for ( var i = 0 ; ( i < children.length ) && ( item = children[i] ) ; i++ )
 						item.getElement().$.checked = ( item.getValue() == value );
-					this.fire( 'change', { value : value } );
+					!noChangeEvent && this.fire( 'change', { value : value } );
 				},
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/filebrowser/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/filebrowser/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/filebrowser/plugin.js	(revision 5841)
@@ -175,5 +175,5 @@
 
 		var url = addQueryString( this.filebrowser.url, params );
-		editor.popup( url, width, height );
+		editor.popup( url, width, height, editor.config.fileBrowserWindowFeatures );
 	}
 
@@ -480,2 +480,12 @@
  * config.filebrowserImageBrowseLinkUrl = '/browser/browse.php';
  */
+
+/**
+ * The "features" to use in the file browser popup window.
+ * @name CKEDITOR.config.filebrowserWindowFeatures
+ * @since 3.4.1
+ * @type String
+ * @default 'location=no,menubar=no,toolbar=no,dependent=yes,minimizable=no,modal=yes,alwaysRaised=yes,resizable=yes,scrollbars=yes'
+ * @example
+ * config.filebrowserWindowFeatures = 'resizable=yes,scrollbars=no';
+ */
Index: CKEditor/branches/versions/3.5.x/_source/plugins/floatpanel/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/floatpanel/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/floatpanel/plugin.js	(revision 5841)
@@ -260,4 +260,26 @@
 							if ( top + panelSize.height > viewportSize.height + windowScroll.y )
 								top -= panelSize.height;
+
+							// If IE is in RTL, we have troubles with absolute
+							// position and horizontal scrolls. Here we have a
+							// series of hacks to workaround it. (#6146)
+							if ( CKEDITOR.env.ie )
+							{
+								var offsetParent = new CKEDITOR.dom.element( element.$.offsetParent ),
+									scrollParent = offsetParent;
+
+								// Quirks returns <body>, but standards returns <html>.
+								if ( scrollParent.getName() == 'html' )
+									scrollParent = scrollParent.getDocument().getBody();
+
+								if ( scrollParent.getComputedStyle( 'direction' ) == 'rtl' )
+								{
+									// For IE8, there is not much logic on this, but it works.
+									if ( CKEDITOR.env.ie8Compat )
+										left -= element.getDocument().getDocumentElement().$.scrollLeft * 2;
+									else
+										left -= ( offsetParent.$.scrollWidth - offsetParent.$.clientWidth );
+								}
+							}
 
 							element.setStyles(
Index: CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/select.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/select.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/forms/dialogs/select.js	(revision 5841)
@@ -162,10 +162,10 @@
 			if ( isInsertMode )
 			{
-				editor.insertElement(element);
+				editor.insertElement( element );
 				if ( CKEDITOR.env.ie )
 				{
 					var sel = editor.getSelection(),
 						bms = sel.createBookmarks();
-					setTimeout(function ()
+					setTimeout(function()
 					{
 						sel.selectBookmarks( bms );
@@ -194,5 +194,5 @@
 						{
 							if ( name == 'clear' )
-								this.setValue( '' );
+								this.setValue( this.default || '' );
 							else if ( name == 'select' )
 							{
Index: CKEditor/branches/versions/3.5.x/_source/plugins/menu/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/menu/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/menu/plugin.js	(revision 5841)
@@ -222,6 +222,9 @@
 				sortItems( items );
 
+				var chromeRoot = editor.container.getChild( 1 );
+				var mixedContentClass = chromeRoot.hasClass( 'cke_mixed_dir_content' ) ? ' cke_mixed_dir_content' : '';
+
 				// Build the HTML that composes the menu and its items.
-				var output = [ '<div class="cke_menu" role="presentation">' ];
+				var output = [ '<div class="cke_menu' + mixedContentClass + '" role="presentation">' ];
 
 				var length = items.length,
Index: CKEditor/branches/versions/3.5.x/_source/plugins/popup/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/popup/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/popup/plugin.js	(revision 5841)
@@ -4,5 +4,5 @@
 */
 
-CKEDITOR.plugins.add( 'popup');
+CKEDITOR.plugins.add( 'popup' );
 
 CKEDITOR.tools.extend( CKEDITOR.editor.prototype,
@@ -14,6 +14,7 @@
 	 * @param {String} width Popup window width.
 	 * @param {String} height Popup window height.
+	 * @param {String} options Popup window features.
 	 */
-	popup : function( url, width, height )
+	popup : function( url, width, height, options )
 	{
 		width = width || '80%';
@@ -34,5 +35,5 @@
 		var top = parseInt( ( window.screen.height - height ) / 2, 10 ),
 			left = parseInt( ( window.screen.width  - width ) / 2, 10 ),
-			options = 'location=no,menubar=no,toolbar=no,dependent=yes,minimizable=no,modal=yes,alwaysRaised=yes,resizable=yes' +
+			options = ( options || 'location=no,menubar=no,toolbar=no,dependent=yes,minimizable=no,modal=yes,alwaysRaised=yes,resizable=yes,scrollbars=yes' ) +
 			',width='  + width +
 			',height=' + height +
@@ -58,5 +59,5 @@
 		}
 
-		return true ;
+		return true;
 	}
 });
Index: CKEditor/branches/versions/3.5.x/_source/plugins/scayt/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/scayt/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/scayt/plugin.js	(revision 5841)
@@ -497,11 +497,6 @@
 			}
 
-			// Register scayt rbc menu group.
-			if ( editor.config.scayt_contextMenuOntop )
-				// Put it on top of all context menu items
-				editor.config.menu_groups =  items_order_str + ',' + editor.config.menu_groups;
-			else
-				// Put it down
-				editor.config.menu_groups = editor.config.menu_groups + ',' +items_order_str;
+			// Put it on top of all context menu items (#5717)
+			editor.config.menu_groups =  items_order_str + ',' + editor.config.menu_groups;
 		},
 
@@ -932,13 +927,4 @@
 
 /**
- * Makes it possible to place the SCAYT context menu items above others.
- * @name CKEDITOR.config.scayt_contextMenuOntop
- * @type Boolean
- * @default false
- * @example
- * config.scayt_contextMenuOntop = true;
- */
-
-/**
  * Define order of placing of SCAYT context menu items by groups.
  * It must be a string with one or more of the following
Index: CKEditor/branches/versions/3.5.x/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/styles/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/styles/plugin.js	(revision 5841)
@@ -405,5 +405,5 @@
 				var nodeName = nodeType == CKEDITOR.NODE_ELEMENT ? currentNode.getName() : null;
 
-				if ( nodeName && currentNode.getAttribute( '_fck_bookmark' ) )
+				if ( nodeName && currentNode.getAttribute( '_cke_bookmark' ) )
 				{
 					currentNode = currentNode.getNextSourceNode( true );
@@ -813,5 +813,5 @@
 		// Exclude the ones at header OR at tail,
 		// and ignore bookmark content between them.
-		var duoBrRegex = /(\S\s*)\n(?:\s|(<span[^>]+_fck_bookmark.*?\/span>))*\n(?!$)/gi,
+		var duoBrRegex = /(\S\s*)\n(?:\s|(<span[^>]+_cke_bookmark.*?\/span>))*\n(?!$)/gi,
 			blockName = preBlock.getName(),
 			splitedHtml = replace( preBlock.getOuterHtml(),
@@ -835,5 +835,5 @@
 			tailBookmark = '';
 
-		str = str.replace( /(^<span[^>]+_fck_bookmark.*?\/span>)|(<span[^>]+_fck_bookmark.*?\/span>$)/gi,
+		str = str.replace( /(^<span[^>]+_cke_bookmark.*?\/span>)|(<span[^>]+_cke_bookmark.*?\/span>$)/gi,
 			function( str, m1, m2 ){
 					m1 && ( headBookmark = m1 );
Index: CKEditor/branches/versions/3.5.x/_source/plugins/table/dialogs/table.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/table/dialogs/table.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/table/dialogs/table.js	(revision 5841)
@@ -33,6 +33,5 @@
 			onLoad : function()
 			{
-				var dialog = this,
-					isUpdating;
+				var dialog = this;
 
 				var styles = dialog.getContentElement( 'advanced', 'advStyles' );
@@ -42,10 +41,4 @@
 					styles.on( 'change', function( evt )
 						{
-							if ( isUpdating )
-								return;
-
-							// Flag to avoid recursion.
-							isUpdating = 1;
-
 							// Synchronize width value.
 							var width = this.getStyle( 'width', '' ),
@@ -60,6 +53,6 @@
 							}
 
-							txtWidth && txtWidth.setValue( width );
-							cmbWidthType && cmbWidthType.setValue( isPx ? 'pixels' : 'percents' );
+							txtWidth && txtWidth.setValue( width, true );
+							cmbWidthType && cmbWidthType.setValue( isPx ? 'pixels' : 'percents', true );
 
 							// Synchronize height value.
@@ -68,7 +61,5 @@
 
 							height && ( height = parseInt( height, 10 ) );
-							txtHeight && txtHeight.setValue( height );
-
-							isUpdating = 0;
+							txtHeight && txtHeight.setValue( height, true );
 						});
 				}
@@ -89,9 +80,6 @@
 				if ( command == 'tableProperties' )
 				{
-					if ( ( selectedTable = editor.getSelection().getSelectedElement() ) )
-					{
-						if ( selectedTable.getName() != 'table' )
-							selectedTable = null;
-					}
+					if ( ( selectedTable = selection.getSelectedElement() ) )
+						selectedTable = selectedTable.getAscendant( 'table', true );
 					else if ( ranges.length > 0 )
 					{
@@ -109,5 +97,5 @@
 				}
 
-				// Enable, disable and select the row, cols, width fields.
+				// Enable or disable the row, cols, width fields.
 				if ( selectedTable )
 				{
@@ -115,5 +103,4 @@
 					rowsInput && rowsInput.disable();
 					colsInput && colsInput.disable();
-					widthInput && widthInput.select();
 				}
 				else
@@ -121,5 +108,4 @@
 					rowsInput && rowsInput.enable();
 					colsInput && colsInput.enable();
-					rowsInput && rowsInput.select();
 				}
 
Index: CKEditor/branches/versions/3.5.x/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/toolbar/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/toolbar/plugin.js	(revision 5841)
@@ -416,4 +416,5 @@
  *     ['NumberedList','BulletedList','-','Outdent','Indent','Blockquote','CreateDiv'],
  *     ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
+ *     ['BidiLtr', 'BidiRtl' ],
  *     ['Link','Unlink','Anchor'],
  *     ['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak'],
@@ -434,5 +435,5 @@
 	['NumberedList','BulletedList','-','Outdent','Indent','Blockquote','CreateDiv'],
 	['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
-	['BidiLtr', 'BidiRtl'],
+	['BidiLtr', 'BidiRtl' ],
 	['Link','Unlink','Anchor'],
 	['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak'],
Index: CKEditor/branches/versions/3.5.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/wysiwygarea/plugin.js	(revision 5815)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/wysiwygarea/plugin.js	(revision 5841)
@@ -413,6 +413,6 @@
   							'></iframe>' );
 
-						// #5689 Running inside of Firefox chrome the load event doesn't bubble like in a normal page
-						if (document.location.protocol == 'chrome:')
+						// Running inside of Firefox chrome the load event doesn't bubble like in a normal page (#5689)
+						if ( document.location.protocol == 'chrome:' )
 							CKEDITOR.event.useCapture = true;
 
@@ -431,9 +431,32 @@
 							});
 
-						// #5689 Reset adjustment back to default
-						if (document.location.protocol == 'chrome:')
+						// Reset adjustment back to default (#5689)
+						if ( document.location.protocol == 'chrome:' )
 							CKEDITOR.event.useCapture = false;
 
+						// The container must be visible when creating the iframe in FF (#5956)
+						var element = editor.element,
+							isHidden = CKEDITOR.env.gecko && !element.isVisible(),
+							previousStyles = {};
+						if ( isHidden )
+						{
+							element.show();
+							previousStyles = {
+								position : element.getStyle( 'position' ),
+								top : element.getStyle( 'top' )
+							};
+							element.setStyles( { position : 'absolute', top : '-3000px' } );
+						}
+
 						mainElement.append( iframe );
+
+						if ( isHidden )
+						{
+							setTimeout( function()
+							{
+								element.hide();
+								element.setStyles( previousStyles );
+							}, 1000 );
+						}
 					};
 
@@ -892,5 +915,12 @@
 								if ( isLoadingData )
 									isPendingFocus = true;
-								else if ( editor.window )
+								// Temporary solution caused by #6025, supposed be unified by #6154.
+								else if ( CKEDITOR.env.opera && editor.document )
+								{
+									editor.document.getBody().focus();
+
+									editor.selectionChange();
+								}
+								else if ( !CKEDITOR.env.opera && editor.window )
 								{
 									editor.window.focus();
